package cn.ch.server;

import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class Request {	//ڽӿͻ
	private InputStream is;		//
	private String RequestInfo;	//
	private String method;		//ʽ
	private String url;			//url
	
	public String getUrl() {
		return url;
	}
	
	private Map<String,List<String>> parameterMapValue;	//Ĳ
	private static final String CRLF="\r\n";	//
	private static final String BLANK=" ";		//ո
	
	//޲ι췽ʼ
	public Request() {
		parameterMapValue=new HashMap<String,List<String>>();
		RequestInfo="";
		method="";
		url="";
	}
	
	public Request(InputStream is) {
		this();		//ñ޲ι췽
		this.is=is;
		try {
			byte[] buf=new byte[102400];
			int len=this.is.read(buf);
			RequestInfo=new String(buf,0,len);
		} catch (IOException e) {
			return;
		}
		//ñзֽϢķ
		this.parseRequestInfo();
	}
	
	//ֽϢķ
	/**
	 * 
	 * ·
	 * ʽ
	 */
	public void parseRequestInfo() {
		String paraString="";	//洢
		//ֽϢĵһ(ʽ·Э)
		String firstLine=RequestInfo.substring(0, RequestInfo.indexOf(CRLF)).trim();
		//ֽʽ
		int index=firstLine.indexOf("/");
		this.method=firstLine.substring(0, index).trim();
		//ֽurlgetܰҲܲpost
		String urlString=firstLine.substring(index, firstLine.indexOf("HTTP/")).trim();
		//жʽgetpost
		if("get".equalsIgnoreCase(method)) {	
			if(urlString.contains("?")) {	//get
				String[] urlArray=urlString.split("\\?");
				this.url=urlArray[0];
				paraString=urlArray[1];
			}else {							//get
				this.url=urlString;
			}
		}else {								//ʽpost
			this.url=urlString;
			paraString=RequestInfo.substring(RequestInfo.lastIndexOf(CRLF)).trim();
		}
		if(paraString.equals("")) {
			return;
		}
		this.parseParam(paraString);
	}
	
	//ֽ
	public void parseParam(String paraString) {
		//username=chenhao&pwd=123&hobby=ball&hobby=read
		//ֽΪusernamechenhao...ʽ
		String[] token=paraString.split("&");
		for(int i=0;i<token.length;i++) {
			String keyValues=token[i];
			String[] keyValue=keyValues.split("=");
			if(keyValue.length==1) {
				keyValue=Arrays.copyOf(keyValue, 2);
				keyValue[1]=null;
			}
			//ֽĲ洢map(parameterMapValue)
			String key=keyValue[0];
			//ñķֱʹthis
			String value=keyValue[1]==null?null:decode(keyValue[1].trim(), "utf-8");
			if(!parameterMapValue.containsKey(key)) {
				parameterMapValue.put(key,new ArrayList<String>());
			}
			//ͨȡֵMapֵΪListvalues
			List<String> values=parameterMapValue.get(key);
			//value洢valuesУΪhobbyӦֵ
			values.add(value);
		}	
	}
	
	//ͨҳϵnameȡֵ(hobyyname,Ӧֵ)
	public String[] getParameterValues(String name) {
		List<String> values=parameterMapValue.get(name);
		if(values==null) {
			return null;
		}
		return values.toArray(new String[0]);
	}
	
	//ͨҳϵnameȡֵ(username,pwdnameӦһֵ
	public String getParameterValue(String name) {
		String[] value = getParameterValues(name);
		if(value==null) {
			return null;
		}else {
			return value[0];
		}
	}
	
	//ģΪĽ˱룬н
	//ȷ,ؽ
	//󣬷null
	public String decode(String s,String code) {
		try {
			return URLDecoder.decode(s, code);
		} catch (UnsupportedEncodingException e) {
			return null;
		}
	}
	
}
