package cn.ch.server;

import java.io.BufferedWriter;
import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;

import cn.ch.util.IOCloseUtil;

public class Response {	//Ӧͻ
	private StringBuilder headInfo;	//Ӧͷ
	private StringBuilder content; 	//Ӧ
	private int length;				//Ӧݵĳ
	
	private BufferedWriter bw;		//
	
	private String CRLF="\r\n";		//
	
	private String BLANK=" ";		//ո
	
	//췽ʼԱ
	public Response() {
		headInfo=new StringBuilder();
		content=new StringBuilder();
	}
	
	public Response(OutputStream os) {
		this();	//ñ޲ι췽
		try {
			bw=new BufferedWriter(new OutputStreamWriter(os,"utf-8"));
		} catch (UnsupportedEncodingException e) {
			headInfo=null;
		}
	}
	
	/**Ӧ
	ص¼ǷɹӦ
	ӦķΪкͲ
	*/
	
	//ӦĲ
	public Response print(String info) {
		content.append(info);
		try {
			length+=info.getBytes("utf-8").length;
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return this;
	}
	
	//ӦĻ
	public Response println(String info) {
		content.append(info).append(CRLF);
		try {
			length+=info.getBytes("utf-8").length;
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return this;
	}
	
	//Ӧͷ
	public void createHeadInfo(int code) {
		headInfo.append("HTTP/1.1").append(BLANK).append(code).append(BLANK);
		switch(code) {
			case 200:
				headInfo.append("OK");
				break;
			case 500:
				headInfo.append("SERVER ERROR");
				break;
			default:
				headInfo.append("NOT FOUND");
				break;
		}
		headInfo.append("Content-type:text/html;charset-utf-8").append(CRLF);
		headInfo.append("Content-Length"+length).append(CRLF).append(CRLF);
	}
	
	//Ӧ͵ͻ˵
	public void pushToClient(int code) {
		if(headInfo==null) {
			code=500;
		}
		this.createHeadInfo(code);
		try {
			bw.write(headInfo.toString());
			bw.write(content.toString());
			bw.flush();
			this.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void close() {
		IOCloseUtil.CloseAll(bw);
	}
}

























